from cml.usecases.usecase import Usecase
from cml.domain import Preprocessor, DataSource, LearnblockIdentifier


class PreprocessUsecase(Usecase):
    def process(self, request):
        preprocesser = Preprocessor(request.pre_settings)
        cleaned_data = preprocesser.clean(request.source_adapter)
        learnblock_identifier = LearnblockIdentifier(request.block_settings)
        data_source = DataSource(cleaned_data, learnblock_identifier)
        return data_source
